/*****************************************************************************
The Dark Mod GPL Source Code

This file is part of the The Dark Mod Source Code, originally based
on the Doom 3 GPL Source Code as published in 2011.

The Dark Mod Source Code is free software: you can redistribute it
and/or modify it under the terms of the GNU General Public License as
published by the Free Software Foundation, either version 3 of the License,
or (at your option) any later version. For details, see LICENSE.TXT.

Project: The Dark Mod (http://www.thedarkmod.com/)

******************************************************************************/
#include "precompiled.h"
#pragma hdrstop

#include "snd_efxpresets.h"

#define PRESET(name) {#name, EFX_REVERB_PRESET_##name},
EfxPreset efxPresets[] = {
	PRESET(GENERIC)
	PRESET(PADDEDCELL)
	PRESET(ROOM)
	PRESET(BATHROOM)
	PRESET(LIVINGROOM)
	PRESET(STONEROOM)
	PRESET(AUDITORIUM)
	PRESET(CONCERTHALL)
	PRESET(CAVE)
	PRESET(ARENA)
	PRESET(HANGAR)
	PRESET(CARPETEDHALLWAY)
	PRESET(HALLWAY)
	PRESET(STONECORRIDOR)
	PRESET(ALLEY)
	PRESET(FOREST)
	PRESET(CITY)
	PRESET(MOUNTAINS)
	PRESET(QUARRY)
	PRESET(PLAIN)
	PRESET(PARKINGLOT)
	PRESET(SEWERPIPE)
	PRESET(UNDERWATER)
	PRESET(DRUGGED)
	PRESET(DIZZY)
	PRESET(PSYCHOTIC)
	PRESET(CASTLE_SMALLROOM)
	PRESET(CASTLE_SHORTPASSAGE)
	PRESET(CASTLE_MEDIUMROOM)
	PRESET(CASTLE_LARGEROOM)
	PRESET(CASTLE_LONGPASSAGE)
	PRESET(CASTLE_HALL)
	PRESET(CASTLE_CUPBOARD)
	PRESET(CASTLE_COURTYARD)
	PRESET(CASTLE_ALCOVE)
	PRESET(FACTORY_SMALLROOM)
	PRESET(FACTORY_SHORTPASSAGE)
	PRESET(FACTORY_MEDIUMROOM)
	PRESET(FACTORY_LARGEROOM)
	PRESET(FACTORY_LONGPASSAGE)
	PRESET(FACTORY_HALL)
	PRESET(FACTORY_CUPBOARD)
	PRESET(FACTORY_COURTYARD)
	PRESET(FACTORY_ALCOVE)
	PRESET(ICEPALACE_SMALLROOM)
	PRESET(ICEPALACE_SHORTPASSAGE)
	PRESET(ICEPALACE_MEDIUMROOM)
	PRESET(ICEPALACE_LARGEROOM)
	PRESET(ICEPALACE_LONGPASSAGE)
	PRESET(ICEPALACE_HALL)
	PRESET(ICEPALACE_CUPBOARD)
	PRESET(ICEPALACE_COURTYARD)
	PRESET(ICEPALACE_ALCOVE)
	PRESET(SPACESTATION_SMALLROOM)
	PRESET(SPACESTATION_SHORTPASSAGE)
	PRESET(SPACESTATION_MEDIUMROOM)
	PRESET(SPACESTATION_LARGEROOM)
	PRESET(SPACESTATION_LONGPASSAGE)
	PRESET(SPACESTATION_HALL)
	PRESET(SPACESTATION_CUPBOARD)
	PRESET(SPACESTATION_ALCOVE)
	PRESET(WOODEN_SMALLROOM)
	PRESET(WOODEN_SHORTPASSAGE)
	PRESET(WOODEN_MEDIUMROOM)
	PRESET(WOODEN_LARGEROOM)
	PRESET(WOODEN_LONGPASSAGE)
	PRESET(WOODEN_HALL)
	PRESET(WOODEN_CUPBOARD)
	PRESET(WOODEN_COURTYARD)
	PRESET(WOODEN_ALCOVE)
	PRESET(SPORT_EMPTYSTADIUM)
	PRESET(SPORT_SQUASHCOURT)
	PRESET(SPORT_SMALLSWIMMINGPOOL)
	PRESET(SPORT_LARGESWIMMINGPOOL)
	PRESET(SPORT_GYMNASIUM)
	PRESET(SPORT_FULLSTADIUM)
	PRESET(SPORT_STADIUMTANNOY)
	PRESET(PREFAB_WORKSHOP)
	PRESET(PREFAB_SCHOOLROOM)
	PRESET(PREFAB_PRACTISEROOM)
	PRESET(PREFAB_OUTHOUSE)
	PRESET(PREFAB_CARAVAN)
	PRESET(DOME_TOMB)
	PRESET(PIPE_SMALL)
	PRESET(DOME_SAINTPAULS)
	PRESET(PIPE_LONGTHIN)
	PRESET(PIPE_LARGE)
	PRESET(PIPE_RESONANT)
	PRESET(OUTDOORS_BACKYARD)
	PRESET(OUTDOORS_ROLLINGPLAINS)
	PRESET(OUTDOORS_DEEPCANYON)
	PRESET(OUTDOORS_CREEK)
	PRESET(OUTDOORS_VALLEY)
	PRESET(MOOD_HEAVEN)
	PRESET(MOOD_HELL)
	PRESET(MOOD_MEMORY)
	PRESET(DRIVING_COMMENTATOR)
	PRESET(DRIVING_PITGARAGE)
	PRESET(DRIVING_INCAR_RACER)
	PRESET(DRIVING_INCAR_SPORTS)
	PRESET(DRIVING_INCAR_LUXURY)
	PRESET(DRIVING_FULLGRANDSTAND)
	PRESET(DRIVING_EMPTYGRANDSTAND)
	PRESET(DRIVING_TUNNEL)
	PRESET(CITY_STREETS)
	PRESET(CITY_SUBWAY)
	PRESET(CITY_MUSEUM)
	PRESET(CITY_LIBRARY)
	PRESET(CITY_UNDERPASS)
	PRESET(CITY_ABANDONED)
	PRESET(DUSTYROOM)
	PRESET(CHAPEL)
	PRESET(SMALLWATERROOM)
	{"", {}}
};
#undef PRESET
